<div class="booked-settings-wrap wrap"><?php
	
	$calendars = get_terms('booked_custom_calendars','orderby=slug&hide_empty=0');
	$booked_none_assigned = true;
	$default_calendar_id = false;
								
	if (!empty($calendars)):
	
		if (booked_user_role() == 'booked_booking_agent'):
		
			global $current_user;
			$calendars = booked_filter_agent_calendars($current_user,$calendars);
			
			if (empty($calendars)):
				$booked_none_assigned = true;
			else:
				$first_calendar = array_slice($calendars, 0, 1);
				$default_calendar_id = array_shift($first_calendar)->term_id;
				$booked_none_assigned = false;
			endif;
		
		else:
			$booked_none_assigned = false;
		endif;
		
	endif;
	
	if (booked_user_role() == 'booked_booking_agent' && $booked_none_assigned):
		
		echo '<div style="text-align:center;">';
			echo '<br><br><h3>'.__('There are no calendars assigned to you.','booked').'</h3>';
			echo '<p>'.__('Get in touch with the Administration of this site to get a calendar assigned to you.','booked').'</p>';
		echo '</div>';
		
	else:

		?><div class="topSavingState savingState"><i class="fa fa-refresh fa-spin"></i>&nbsp;&nbsp;<?php _e('Updating, please wait...','booked'); ?></div>
		<div class="booked-settings-title"><?php _e('Pending Appointments','booked'); ?></div>
		<div id="data-ajax-url"><?php echo get_admin_url(); ?></div>
	
		<?php
	
		echo '<div class="booked-pending-appt-list">';
	
			$time_format = get_option('time_format');
			$date_format = get_option('date_format');
	
			$calendars = get_terms('booked_custom_calendars','orderby=slug&hide_empty=0');
			if (empty($calendars) && booked_user_role() == 'booked_booking_agent'):
				$args = false;
			else:
				$args = array(
					'post_type' => 'booked_appointments',
					'posts_per_page' => -1,
					'post_status' => 'draft',
					'meta_key' => '_appointment_timestamp',
					'orderby' => 'meta_value_num',
					'order' => 'ASC'
				);
			endif;
	
			$appointments_array = array();
	
			if ($args):
				$bookedAppointments = new WP_Query($args);
				if($bookedAppointments->have_posts()):
					while ($bookedAppointments->have_posts()):
						$bookedAppointments->the_post();
						global $post;
						
						$calendars = array();
		
						$calendar_terms = get_the_terms($post->ID,'booked_custom_calendars');
						if (!empty($calendar_terms)):
							foreach($calendar_terms as $calendar){
								$calendars[$calendar->term_id] = $calendar->name;
							}
						endif;
						
						$guest_name = get_post_meta($post->ID, '_appointment_guest_name',true);
						$guest_email = get_post_meta($post->ID, '_appointment_guest_email',true);
		
						$timestamp = get_post_meta($post->ID, '_appointment_timestamp',true);
						$timeslot = get_post_meta($post->ID, '_appointment_timeslot',true);
						$day = date('d',$timestamp);
						$appointments_array[$post->ID]['post_id'] = $post->ID;
						$appointments_array[$post->ID]['timestamp'] = $timestamp;
						$appointments_array[$post->ID]['timeslot'] = $timeslot;
						$appointments_array[$post->ID]['status'] = $post->post_status;
						$appointments_array[$post->ID]['calendar'] = implode(',',$calendars);
						
						if (!$guest_name):
							$user_id = get_post_meta($post->ID, '_appointment_user',true);
							$appointments_array[$post->ID]['user'] = $user_id;
						else:
							$appointments_array[$post->ID]['guest_name'] = $guest_name;
							$appointments_array[$post->ID]['guest_email'] = $guest_email;
						endif;
						
					endwhile;
					$appointments_array = apply_filters('booked_appointments_array', $appointments_array);
				endif;
			endif;
	
			/*
			Let's loop through the pending appointments
			*/
			
			if (!empty($appointments_array)):
	
				foreach($appointments_array as $appt):
		
					echo '<div class="pending-appt bookedClearFix" data-appt-id="'.$appt['post_id'].'">';
		
						if (!isset($appt['guest_name'])):
							$user_info = get_userdata($appt['user']);
							if (isset($user_info->ID)):
								if ($user_info->user_firstname):
									$user_display = '<a href="#" class="user" data-user-id="'.$appt['user'].'">'.$user_info->user_firstname.($user_info->user_lastname ? ' '.$user_info->user_lastname : '').'</a>';
								elseif ($user_info->display_name):
									$user_display = '<a href="#" class="user" data-user-id="'.$appt['user'].'">'.$user_info->display_name.'</a>';
								else :
									$user_display = '<a href="#" class="user" data-user-id="'.$appt['user'].'">'.$user_info->user_login.'</a>';
								endif;
							else :
								$user_display = __('(this user no longer exists)','booked');
							endif;
						else :
							$user_display = '<a href="#" class="user" data-user-id="0">'.$appt['guest_name'].'</a>';
						endif;
		
						$date_display = date_i18n($date_format,$appt['timestamp']);
						$day_name = date_i18n('l',$appt['timestamp']);
		
						$timeslots = explode('-',$appt['timeslot']);
						$time_start = date($time_format,strtotime($timeslots[0]));
						$time_end = date($time_format,strtotime($timeslots[1]));
		
						$date_to_compare = strtotime(date('F j, Y',$appt['timestamp']).' '.date('H:i:s',strtotime($timeslots[0])));
						$late_date = current_time('timestamp');
		
						if ($timeslots[0] == '0000' && $timeslots[1] == '2400'):
							$timeslotText = __('All day','booked');
						else :
							$timeslotText = $time_start.'&ndash;'.$time_end;
						endif;
		
						$status = ($appt['status'] == 'draft' ? 'pending' : 'approved');
						echo '<span class="appt-block" data-appt-id="'.$appt['post_id'].'">';
							
							echo '<button data-appt-id="'.$appt['post_id'].'" class="approve button button-primary">'.__('Approve','booked').'</button>';
							echo '<button class="delete button">'.__('Delete','booked').'</button>';
		
							echo $user_display;
							
							echo '<br>';
							if ($late_date > $date_to_compare): echo '<span class="late-appt">' . __('This appointment has passed.','booked') . '</span><br>'; endif;
							if ($appt['calendar']): echo '<i class="fa fa-calendar"></i>&nbsp;&nbsp;<strong>'.$appt['calendar'].'</strong>: '; endif;
							echo $day_name.', '.$date_display;
							echo '<br><i class="fa fa-clock-o"></i>&nbsp;&nbsp;'.$timeslotText;
		
						echo '</span>';
		
					echo '</div>';
		
				endforeach;
			
			endif;
			
			echo '<div class="pending-appt'.(!empty($appointments_array) ? ' no-pending-message' : '').'">';
				echo '<p style="text-align:center; margin:3em 0 2em">'.__('There are no pending appointments.','booked').'</p>';
			echo '</div>';
	
		echo '</div>';
		
	endif;

	?>

</div>